@startuml
title 2b removeGenericStep 
actor Actor
participant "CatERingAppManager.kitchenJobManager:KitchenJobManager" as kjm
participant "parentGroup: GroupStep" as gps
participant "r: KitchenJobReceiver" as rec

Actor -> kjm++: removeGenericStep(genericStep, parentGroup)

alt currentKitchenJob == null 
  kjm -->> Actor: throw UseCaseLogicException
else !currentKitchenJob.hasStep(genericStep) 
  kjm -->> Actor: throw UseCaseLogicException
else genericStep == currentKitchenJob.getRootGroup()
  kjm -->> Actor: throw UseCaseLogicException
else
  'Se genericStep è un GroupStep i GenericStep contenuti in esso saranno rimossi dal garbage collector
  kjm -> gps ++:removeChildren(GenericStep)
  deactivate gps
  group for each r in receivers
    kjm -> rec++:notifyGenericStepRemoved(currentKitchenJob, genericStep, parentGroup)
    deactivate rec
  end 
  kjm -->> Actor--
end
@enduml
